using UnityEngine;
using System.Collections;

public class StageData {
	
	public const int BACKGROUND_BLANK = 0;
	public const int BACKGROUND_WALL = 1;
	public const int BACKGROUND_GOLD = 2;
	public const int BACKGROUND_CHAIN = 3;
	public const int BACKGROUND_DCHAIN = 4;
	public const int BACKGROUND_TCHAIN = 5;
	public const int BACKGROUND_W_BLANK = 6;
	public const int BACKGROUND_GOLD_H = 7;
	public const int BACKGROUND_WALL_TYPE1 = 8;
	public const int BACKGROUND_WALL_TYPE2 = 9;
	public const int BACKGROUND_ICE_TYPE1 = 10;
	public const int BACKGROUND_ICE_TYPE2 = 11;
	public const int BACKGROUND_ICE_TYPE3 = 12;
	public const int BACKGROUND_ICE_TYPE4 = 13;
	public const int BACKGROUND_ICE_TYPE5 = 14;
	/*
	private static int[,] stage1Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	 * */
	
	private static int[,] stage1Data = {
		/*
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
		*/
		{0,0,0,0,0,0,0,0},
		{1,0,0,0,0,0,0,1},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage128Data = {
		{ 9, 9, 3, 9, 4,12,12, 9},
		{ 9, 1, 1, 1, 9, 1, 1, 8},
		{14, 4, 1, 3,14, 1, 3,14},
		{ 1,13, 0, 0, 0, 0, 0, 1},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 1, 0, 0, 1, 0, 0},
		{ 0, 1, 1, 1, 0, 1, 1, 0}
	};
	private static int[,] stage127Data = {
		{ 9, 9, 9, 9, 4, 9, 3, 4},
		{ 9, 4, 4, 9, 9, 8, 8, 3},
		{ 8, 1, 1, 1,12,11,11,10},
		{13, 1, 1,14,14, 0, 0,14},
		{13, 0, 0, 0, 0, 1, 1,14},
		{ 0, 0, 0, 0, 1, 1, 1,14},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage126Data = {
		{ 9, 9, 3, 9, 1, 4, 4, 9},
		{ 9, 9, 9, 4, 1, 9, 9, 9},
		{ 9, 9, 1, 1, 1, 1, 8, 8},
		{13,14,14,14, 4, 8,14, 0},
		{ 0, 0, 0, 0, 0, 4, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 1, 1, 1, 1, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0}
	};
	private static int[,] stage125Data = {
		{ 9, 9, 3, 9, 9, 9, 4, 4},
		{ 9, 9, 4, 1, 9, 1, 1, 9},
		{12, 1, 8, 4,13, 1, 1, 8},
		{10, 0, 0, 0, 0, 0, 0, 4},
		{ 0, 0, 0, 1, 1, 0, 0, 0},
		{ 0, 0, 1, 0, 0, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage124Data = {
		{ 4, 9, 4, 9, 9, 3, 9, 3},
		{ 4, 9, 9, 1, 1, 1, 9, 9},
		{ 8,13, 4,13, 1, 3, 4, 8},
		{11,12, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 4, 0},
		{ 0, 1, 1, 1, 0, 1, 1, 0},
		{ 0, 0, 0, 1, 1, 0, 0, 0}
	};
	private static int[,] stage123Data = {
		{ 9, 9, 4, 9, 9, 4, 4, 9},
		{ 9, 1, 1, 1, 9, 1, 1, 9},
		{11, 1, 4, 3, 8,12,13,10},
		{ 8, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 1, 0, 0, 0, 0},
		{ 0, 0, 1, 1, 0, 1, 0, 0},
		{ 0, 1, 1, 1, 0, 1, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage122Data = {
		{ 9, 9, 3,10, 9, 4, 4, 9},
		{ 9, 9, 4, 9, 9, 4, 3, 9},
		{ 9,12, 1, 1, 1, 1,13, 8},
		{11,13, 1, 3, 4, 1,13, 0},
		{ 0, 0, 1, 0, 0, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 1, 0, 0, 0, 0, 1, 0},
		{ 1, 0, 0, 0, 0, 0, 0, 1}
	};
	private static int[,] stage121Data = {
		{ 9, 9, 9, 4, 3, 9, 9, 9},
		{ 9,12, 4, 9, 3, 4,13, 8},
		{ 8, 1, 1, 1, 1, 1, 1, 8},
		{13, 1, 4,11, 8, 3, 1, 8},
		{ 0, 1, 1, 0, 3, 1, 1, 0},
		{ 0, 0, 1, 0, 0, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage120Data = {
		{ 9, 4, 9, 9, 9, 9, 4, 9},
		{ 9, 1, 3, 9, 9, 8, 1, 8},
		{ 8, 1, 1, 4,13, 1, 1,11},
		{ 8, 1, 4, 1,12, 8, 1,11},
		{ 0, 1, 0, 0, 0, 0, 1, 0},
		{ 0, 1, 0, 0, 0, 0, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage119Data = {
		{ 9, 3, 9, 9, 9, 4, 9, 3},
		{ 9, 1, 1, 9, 9, 1, 1, 8},
		{ 8, 1, 4, 4,12, 4, 1,11},
		{13, 8,13, 8, 1, 0, 4, 0},
		{ 0, 0, 0, 1, 1, 0, 0, 0},
		{ 0, 1, 0, 0, 0, 0, 1, 0},
		{ 0, 1, 1, 0, 0, 1, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage118Data = {
		{ 9, 4, 4, 9, 9, 8, 8, 4},
		{ 8, 1, 1, 8, 8, 8, 8, 3},
		{13, 1, 4,13, 9, 9,13, 4},
		{ 0, 0, 0,13, 1, 0, 0, 0},
		{ 0, 0, 0, 1, 1, 0, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 1, 0},
		{ 0, 0, 0, 0, 1, 1, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage117Data = {
		{ 3, 4, 9, 4, 4, 9, 9, 4},
		{ 9, 8, 8, 1, 1, 1, 8, 8},
		{ 8, 8,11, 8,12, 8,12, 8},
		{ 3,13,13, 1, 1, 1,12, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 1, 1, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage116Data = {
		{ 4, 9, 4, 9, 9, 4, 4, 3},
		{ 9,12, 8, 8,12, 4, 8, 8},
		{ 0, 1, 0, 1,12,12, 1, 0},
		{ 0, 1, 0, 1, 0, 0, 1, 0},
		{ 0, 1, 0, 1, 0, 0, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage115Data = {
		{ 9, 4, 4, 9, 9, 9, 9, 3},
		{ 8, 8, 1, 1, 1, 1, 1, 8},
		{12,12, 4, 0, 0, 1, 4,12},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 1, 0, 0, 0, 0},
		{ 0, 0, 1, 1, 1, 1, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage114Data = {
		{ 9, 3, 4, 9, 4, 3, 9, 1},
		{ 9, 8, 8, 1, 8, 8, 1, 4},
		{11, 1, 1, 4,12,12,12,12},
		{ 0, 4, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 1, 1, 0, 0},
		{ 0, 0, 0, 1, 1, 1, 0, 0},
		{ 0, 1, 0, 1, 1, 0, 0, 0},
		{ 1, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage113Data = {
		{ 1, 9, 9, 3, 9, 8, 4, 1},
		{ 4, 8, 4, 8, 8, 9, 9, 8},
		{ 1, 4, 1,12,12, 1, 3, 1},
		{ 1, 0, 0, 0, 0, 0, 0, 1},
		{ 0, 1, 0, 0, 0, 0, 1, 4},
		{ 0, 0, 1, 0, 0, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage112Data = {
		{ 9, 9, 4, 1, 1, 1, 1, 9},
		{ 8, 8, 4, 8, 8, 8, 8,11},
		{12,12, 1,12,10,12, 1,11},
		{ 0, 0, 0, 1, 0, 1,12, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 1, 0, 0, 0,12, 0},
		{ 0, 0, 0, 1, 0, 1, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0}
	};
	private static int[,] stage111Data = {
		{ 9, 9, 9, 1, 9, 4, 9, 9},
		{ 9, 8, 4, 1, 8, 3, 8, 8},
		{12, 4,12, 1,11,11,11, 4},
		{12, 0, 0, 1,10,12, 0, 0},
		{ 0, 0, 0, 1, 0, 3, 0, 0},
		{ 0, 0, 0, 1, 0, 0, 0, 0},
		{ 0, 0, 0, 1, 0, 0, 0, 0},
		{ 0, 0, 0, 1, 0, 0, 0, 0}
	};
	private static int[,] stage110Data = {
		{ 9, 1, 1, 4, 9, 4, 3, 9},
		{ 9, 1, 3, 4, 9, 1,11, 8},
		{ 8,12,12,12, 1, 1, 3,12},
		{ 8, 8, 8, 1, 1, 1, 0, 0},
		{ 0, 0, 0, 0, 4, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 1, 0, 0},
		{ 0, 1, 1, 0, 0, 1, 0, 0}
	};
	private static int[,] stage109Data = {
		{ 3, 9, 4, 9, 3, 4, 8, 8},
		{ 9, 9, 1, 4, 9, 1, 8, 8},
		{ 3,12, 1, 8, 8, 1,10, 0},
		{ 0, 0, 1, 0, 0, 1, 0, 0},
		{ 0, 0, 1, 0, 0, 1, 0, 0},
		{ 0, 0, 1, 0, 0, 1, 0, 0},
		{ 0, 0, 1, 0, 0, 1, 0, 0},
		{ 0, 0, 4, 0, 0, 4, 0, 0}
	};
	private static int[,] stage108Data = {
		{ 4, 8, 8, 9, 4, 1, 1, 4},
		{ 8,11,12,11, 3, 1, 3, 8},
		{ 8, 9, 1,10, 9,12,12,12},
		{ 0, 1, 1, 0, 0, 8, 8, 8},
		{ 0, 3, 0, 0, 1, 1, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 1, 0, 1, 1, 0, 0, 0, 1}
	};
	private static int[,] stage107Data = {
		{12, 4, 3, 9, 4, 4, 9, 3},
		{12, 9, 1, 1, 1, 1, 1, 3},
		{ 9,12, 1, 8, 1, 8, 1,12},
		{ 8, 0, 1, 0, 1, 0, 1, 8},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 1, 0, 0, 1, 1, 1, 0, 0},
		{ 1, 0, 0, 0, 0, 0, 0, 1}
	};
	private static int[,] stage106Data = {
		{ 1, 1, 8, 9, 9, 3, 9, 1},
		{ 4, 1, 8, 3, 9, 8, 1, 1},
		{12,12, 4,11, 3,12,12, 9},
		{ 0, 0, 0, 0, 0, 0, 0,12},
		{ 0, 0, 0, 0, 0, 0, 0,12},
		{ 1, 1, 1, 0, 0, 1, 0, 0},
		{ 1, 1, 0, 0, 0, 1, 1, 4},
		{ 1, 4, 0, 0, 0, 1, 1, 1}
	};
	private static int[,] stage105Data = {
		{ 8, 4, 1, 4, 8, 3, 4, 4},
		{ 8, 3, 4, 1, 8, 8, 8, 8},
		{ 8,12, 3, 8, 1, 8,12, 3},
		{12, 1, 8, 9, 9, 1,12,12},
		{ 0, 0, 1, 9, 9, 4, 0,12},
		{ 0, 0, 0, 1, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 1},
		{ 0, 0, 0, 0, 0, 0, 1, 1}
	};
	private static int[,] stage104Data = {
		{ 1, 4, 1, 4, 8, 4, 9, 4},
		{ 4, 8, 9, 1, 8, 9, 3, 9},
		{ 1,11,11,11, 1,10,11, 3},
		{ 1, 3, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 1, 0, 0, 0, 1},
		{ 0, 0, 1, 0, 0, 0, 1, 1},
		{ 0, 0, 0, 1, 0, 0, 0, 1},
		{ 0, 0, 0, 0, 1, 0, 0, 0}
	};
	private static int[,] stage103Data = {
		{ 8, 4, 4, 1, 4, 4, 3, 4},
		{ 8,11, 1,11,11,11, 3, 3},
		{ 8, 9, 8, 9, 9, 9, 4, 1},
		{ 8, 0, 0, 0, 0, 9, 1, 3},
		{ 0, 1, 0, 0, 0, 1, 0, 0},
		{ 0, 0, 1, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage102Data = {
		{ 8, 4, 1, 4,11, 8, 1, 3},
		{ 8, 4, 3, 1, 9, 1, 4, 8},
		{ 8, 4, 9, 8,11, 4,11, 8},
		{ 9, 3, 0, 0, 0, 0, 0, 8},
		{ 9, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 1, 0, 1, 0, 0},
		{ 0, 0, 1, 0, 0, 0, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage101Data = {
		{ 3, 3, 8, 4, 8, 4, 8, 8},
		{ 3, 1, 1, 1, 9, 4, 1, 9},
		{11, 1, 1, 1, 9, 8, 4, 8},
		{ 0,11, 8,11,11, 1,11, 8},
		{ 0, 0, 1, 1, 0, 1,11, 0},
		{ 0, 0, 0, 0, 0, 1, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage100Data = {
		{ 8, 8, 8, 4, 8, 8, 8, 8},
		{11,11,11,11, 8, 1, 3, 8},
		{ 0, 1,11,11, 1, 4, 8, 8},
		{ 0, 0, 1,11,11, 1, 8, 8},
		{ 0, 0, 4, 1, 3, 0, 1, 0},
		{ 0, 0, 1, 0, 0, 0, 0, 0},
		{ 0, 1, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage99Data = {
		{ 8, 8, 1, 4, 8, 4, 8, 8},
		{ 8, 3,11, 8, 8, 1, 1, 8},
		{ 0, 0, 0, 0,11, 4, 1,11},
		{ 0, 0, 1, 1, 1, 0, 0,11},
		{ 0, 0, 4, 1, 1, 0, 0, 0},
		{ 0, 0, 1, 4, 1, 0, 0, 0},
		{ 0, 1, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage98Data = {
		{ 8, 8, 9, 3, 3,11, 8,11},
		{11, 1, 1, 9, 9, 8, 8,11},
		{11, 1,11, 1, 9, 1, 1,11},
		{11, 0, 0, 0, 0, 4, 1, 0},
		{ 0, 0, 4, 0, 0, 1, 0, 0},
		{ 0, 0, 1, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage97Data = {
		{10,10, 4, 9, 9, 8, 8, 8},
		{11,10, 9, 9, 1, 8,10,10},
		{11,11, 9, 9, 4, 1,11,11},
		{ 0, 0, 1,10, 1, 0, 0, 0},
		{ 0, 1, 4, 0, 0, 0, 0, 0},
		{ 0, 0, 1, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 1, 0},
		{ 0, 0, 0, 0, 0, 1, 1, 3}
	};
	private static int[,] stage96Data = {
		{10, 8, 8, 9, 9, 9, 8, 8},
		{10,10, 8, 9, 1, 1, 8, 8},
		{ 0,10,10, 1, 3, 1, 8,10},
		{ 0, 0, 0, 0, 0, 4, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 1, 4, 0, 0, 0, 0},
		{ 0, 4, 1, 1, 0, 0, 0, 1},
		{ 0, 0, 0, 0, 0, 0, 1, 1}
	};
	private static int[,] stage95Data = {
		{10, 8, 8, 9, 9, 8, 8, 8},
		{10,10, 8, 1, 1, 1, 8, 8},
		{ 4,10,10, 4, 1, 9,10,10},
		{ 0, 0,10, 4, 1, 9,10, 0},
		{ 0, 0, 0, 1, 1, 1, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 1, 1, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage94Data = {
		{10, 8, 8, 9, 9, 8, 3, 1},
		{10, 8, 4, 1, 9, 8, 8, 8},
		{10,10, 1, 1, 4, 0, 0, 8},
		{ 0, 0, 0, 9, 1, 0, 0, 0},
		{ 0, 0, 1, 1, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 1, 0, 0, 0, 0, 0, 3, 0},
		{ 1, 1, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage93Data = {
		{ 8, 8, 9, 9, 9, 8, 8, 4},
		{ 8, 4, 3, 1, 9, 9, 8, 8},
		{10, 8, 1, 3, 9, 8, 8, 8},
		{10,10, 8, 4, 1, 8, 8,10},
		{ 0, 0, 0, 1, 4, 8, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 1, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 3, 0}
	};
	private static int[,] stage92Data = {
		{10, 8, 0, 1,10, 9, 9, 9},
		{10, 1, 1, 4,10,10, 9, 9},
		{ 8, 8, 8, 8,10,10,10,10},
		{ 0, 0, 1, 4, 0, 3, 8,10},
		{ 0, 4, 0, 0, 0, 1, 0, 0},
		{ 0, 4, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 4, 1, 1, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0}
	};
	private static int[,] stage91Data = {
		{ 0, 0,10,10,10,10,10, 8},
		{ 0, 0, 1, 9, 9, 9, 1, 8},
		{ 0, 0, 9, 4, 4, 4, 9, 8},
		{ 0, 0, 9, 4, 1, 4, 9, 8},
		{ 0, 0, 9, 4, 4, 4, 9, 8},
		{ 0, 0, 1, 9, 9, 9, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage90Data = {
		{ 1, 8, 9, 8, 1, 1, 8, 1},
		{ 9, 1, 9,10, 3, 9, 9, 8},
		{10,10, 4,10, 1, 1,10,10},
		{10, 0, 0, 0, 0, 0, 0,10},
		{ 1, 0, 0, 0, 4, 0, 0, 1},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 4, 0, 0, 0, 0, 0},
		{ 1, 0, 1, 0, 1, 0, 1, 1}
	};
	private static int[,] stage89Data = {
		{10, 8, 0, 1, 8, 1, 1,10},
		{10, 1, 1, 8, 8, 9, 1,10},
		{10,10,10, 8, 9, 9,10,10},
		{ 0, 0, 4, 1, 4, 1, 3, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 1, 1, 0, 0, 1, 1, 0},
		{ 0, 0, 0, 1, 1, 0, 0, 0}
	};
	private static int[,] stage88Data = {
		{ 4, 1, 9,10, 9, 8, 3, 9},
		{ 0, 0, 0, 0, 4,10,10, 8},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 1, 0, 1, 0, 1, 0, 0},
		{ 0, 1, 0, 1, 0, 1, 0, 0},
		{ 0,10, 1, 0, 0, 0, 1, 0},
		{ 0,10, 1, 0, 0, 0, 1, 0},
		{ 0,10, 1, 0, 0, 0, 1, 0}
	};
	private static int[,] stage87Data = {
		{10, 8, 9, 9, 1, 9, 8,10},
		{10, 4, 1, 9, 9, 1, 4,10},
		{10, 3, 8, 8, 8, 0, 3,10},
		{ 0, 0, 0, 1, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 4, 0, 0, 1, 0, 4, 0},
		{ 0, 3, 1, 0, 1, 1, 3, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage86Data = {
		{ 1, 1, 9,10, 9,10, 9,10},
		{ 9, 8, 9, 8, 9, 8, 4, 9},
		{10,10,10,10,10, 1, 3,10},
		{ 0, 0, 8, 1,10, 9, 1, 8},
		{ 0, 1, 9, 0, 0, 0, 0, 0},
		{ 0, 3, 1, 0, 0, 0, 0, 0},
		{ 0, 4, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 1, 1}
	};
	private static int[,] stage85Data = {
		{ 9, 1, 9, 8,10,10, 1, 1},
		{ 3, 1, 9, 8,10,10, 4, 1},
		{ 4, 1, 1, 1, 1,10,10,10},
		{10,10, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 1, 1, 1, 1, 4},
		{ 1, 3, 0, 0, 0, 0, 1, 3},
		{ 1, 1, 0, 0, 0, 0, 1, 9}
	};
	private static int[,] stage84Data = {
		{ 1, 4, 9, 8,10,10, 4, 1},
		{ 9, 1, 9, 8,10,10, 1, 4},
		{ 8, 8, 3, 1,10,10,10,10},
		{ 8, 8, 1, 1,10, 1,10,10},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 1, 0, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 6},
		{ 1, 0, 0, 0, 0, 0, 6, 1}
	};
	private static int[,] stage83Data = {
		{ 1, 3, 9,10,10,10,14, 1},
		{ 8, 8, 8, 9, 1, 9, 9,10},
		{10,10, 4,10, 9, 9, 9,10},
		{ 0, 0, 0, 0, 1,10,10,10},
		{ 0, 1, 0, 1, 1, 1, 0, 0},
		{ 0, 0, 3, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 1, 0, 0, 0, 0, 0, 0, 1}
	};
	private static int[,] stage82Data = {
		{ 4, 9, 9, 1, 1, 1, 1,10},
		{10,10,10, 9, 9, 9,10, 9},
		{ 1,10,10,10, 1, 1, 1,10},
		{10,10, 0, 0, 3, 1, 0, 0},
		{ 0, 0, 0, 0, 4, 0, 0, 0},
		{ 0, 0, 1, 1, 1, 0, 0, 1},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 1, 1, 1, 0, 1}
	};
	private static int[,] stage81Data = {
		{ 1, 3, 9, 9, 9, 9, 3, 1},
		{ 3, 1, 1, 9, 8, 1, 1, 4},
		{10, 1, 9,10,10, 8, 1, 9},
		{ 0,10,10, 3, 3,10,10, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 1, 0, 0, 0, 0, 1, 0},
		{ 9, 1, 1, 0, 0, 1, 1, 9},
		{ 1, 9, 0, 0, 0, 0, 9, 1}
	};
	private static int[,] stage80Data = {
		{ 3, 1, 3, 8, 8, 8, 8, 8},
		{ 9, 1, 9, 8, 8, 8, 9, 8},
		{ 0, 8, 9, 8, 8, 8, 9, 8},
		{ 0, 0, 8, 1, 3, 1, 9, 9},
		{ 0, 0, 0, 4, 4, 3, 9, 0},
		{ 0, 0, 0, 1, 4, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage79Data = {
		{ 9, 9, 8, 8, 8, 8, 8, 8},
		{ 9, 9, 1, 9, 1, 8, 8, 8},
		{ 0, 9, 9, 4, 3, 8, 8, 8},
		{ 0, 0, 1, 4, 1, 4, 0, 0},
		{ 0, 0, 9, 3, 9, 0, 0, 0},
		{ 0, 0, 1, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage78Data = {
		{ 3, 8, 8, 9, 8, 8, 8, 4},
		{ 9, 8, 1, 9, 8, 1, 8, 9},
		{ 9, 8, 1, 9, 8, 1, 8, 9},
		{ 9, 1, 9, 3, 3, 9, 1, 9},
		{ 0, 1, 0, 3, 4, 0, 1, 9},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage77Data = {
		{ 9, 8, 8, 8, 4, 8, 8, 3},
		{ 9, 9, 8, 8, 1, 8, 8, 9},
		{ 0, 9, 9, 8, 1, 8, 9, 0},
		{ 0, 0, 9, 1, 9, 4, 0, 0},
		{ 0, 0, 4, 1, 9, 1, 0, 0},
		{ 0, 0, 0, 1, 9, 3, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage76Data = {
		{ 9, 9, 9, 9, 9, 9, 1, 1},
		{ 9, 9, 9, 9, 8, 8, 1, 1},
		{ 4, 9, 8, 8, 8, 8, 8, 4},
		{ 3, 1, 8, 8, 8, 8, 8, 4},
		{ 0, 1, 1, 4, 1, 3, 1, 0},
		{ 0, 1, 0, 0, 0, 0, 0, 0},
		{ 0, 1, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage75Data = {
		{ 9, 9, 9, 8, 9, 3, 3, 8},
		{ 8, 9, 3, 8, 8, 8, 3, 4},
		{ 9, 9, 8, 9, 9, 1, 1, 4},
		{ 8, 4, 9, 9, 0, 0, 1, 4},
		{ 4, 1, 1, 0, 0, 0, 0, 0},
		{ 8, 1, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage74Data = {
		{ 9, 8, 8, 8, 8, 4, 3, 4},
		{ 9, 8, 4, 9, 9, 3, 1, 9},
		{ 9, 1, 9, 8, 8, 8, 8, 8},
		{ 9, 4, 9, 0, 1, 8, 8, 0},
		{ 0, 0, 1, 0, 3, 0, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 1, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage73Data = {
		{ 9, 8, 8, 8, 8, 8, 8, 9},
		{ 9, 8, 8, 4, 1, 4, 8, 9},
		{ 9, 3, 1, 1, 1, 1, 4, 9},
		{ 9, 1, 3, 9, 1, 4, 1, 9},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 1, 1, 1, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage72Data = {
		{ 3, 1, 4, 1, 4, 1, 3, 1},
		{ 8, 1, 8, 1, 8, 1, 8, 1},
		{ 8, 8, 8, 3, 3, 3, 8, 8},
		{ 0, 8, 0, 0, 0, 0, 0, 8},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 1, 0, 1, 0, 1, 0, 1},
		{ 0, 1, 0, 1, 0, 1, 0, 1}
	};
	private static int[,] stage71Data = {
		{ 1, 1, 8, 8, 8, 8, 8, 8},
		{ 1, 8, 8, 4, 1, 8, 8, 8},
		{ 0, 8, 8, 1, 3, 8, 4, 8},
		{ 0, 0, 8, 8, 1, 8, 8, 0},
		{ 0, 0, 3, 8, 8, 1, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 1, 0, 0, 4, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0}
	};
	private static int[,] stage70Data = {
		{ 3, 1, 4, 8, 8, 4, 1, 3},
		{ 3, 1, 4, 8, 8, 4, 1, 3},
		{ 8, 8, 1, 8, 8, 1, 8, 8},
		{ 0, 8, 1, 8, 8, 1, 8, 0},
		{ 0, 0, 0, 8, 8, 8, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage69Data = {
		{ 4, 8, 8, 4, 8, 8, 8, 8},
		{ 8, 1, 8, 8, 8, 3, 3, 8},
		{ 0, 8, 8, 8, 8, 1, 1, 8},
		{ 0, 0, 8, 8, 4, 4, 8, 8},
		{ 0, 0, 0, 8, 1, 8, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 0, 1, 1, 0, 0, 0, 0, 0},
		{ 4, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage68Data = {
		{ 8, 8, 8, 8, 8, 8, 8, 8},
		{ 8, 8, 1, 4, 8, 8, 8, 8},
		{ 0, 8, 4, 1, 4, 3, 8, 8},
		{ 0, 0, 3, 1, 1, 4, 3, 8},
		{ 0, 3, 0, 0, 8, 3, 1, 8},
		{ 0, 0, 1, 1, 0, 0, 0, 8},
		{ 0, 0, 0, 1, 0, 0, 0, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage67Data = {
		{ 1, 8, 8, 8, 8, 3, 8, 8},
		{ 1, 8, 8, 1, 8, 8, 8, 3},
		{ 0, 8, 4, 3, 8, 8, 8, 8},
		{ 0, 1, 8, 4, 4, 3, 8, 8},
		{ 0, 0, 0, 8, 8, 1, 8, 8},
		{ 0, 0, 0, 0, 0, 0, 8, 1},
		{ 0, 0, 0, 1, 0, 0, 1, 1},
		{ 0, 0, 0, 0, 0, 0, 1, 1}
	};
	private static int[,] stage66Data = {
		{ 1, 1, 8, 8, 4, 8, 8, 1},
		{ 1, 1, 8, 8, 4, 8, 8, 1},
		{ 0, 8, 8, 8, 1, 8, 8, 8},
		{ 0, 0, 8, 4, 8, 4, 8, 0},
		{ 0, 0, 1, 3, 1, 4, 1, 0},
		{ 0, 0, 0, 3, 4, 8, 0, 0},
		{ 0, 0, 0, 0, 1, 0, 0, 0},
		{ 1, 1, 0, 0, 0, 0, 0, 1}
	};
	private static int[,] stage65Data = {
		{ 8, 4, 8, 8, 8, 8, 8, 8},
		{ 3, 1, 8, 8, 3, 8, 1, 4},
		{ 8, 4, 3, 8, 8, 8, 8, 8},
		{ 8, 8, 0, 0, 0, 0, 8, 8},
		{ 0, 0, 0, 0, 0, 0, 0, 0},
		{ 0, 8, 0, 0, 0, 0, 8, 0},
		{ 0, 1, 8, 0, 0, 8, 1, 0},
		{ 0, 0, 0, 0, 0, 0, 0, 0}
	};
	private static int[,] stage64Data = {
		{1,0,0,3,0,0,0,1},
		{0,4,0,0,3,3,1,0},
		{0,0,4,4,4,1,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,1,0,0,3,0,0},
		{0,1,0,0,0,0,1,0}
	};
	private static int[,] stage63Data = {
		{0,0,1,0,1,0,0,0},
		{0,0,1,0,0,1,1,0},
		{0,0,1,0,0,0,1,0},
		{0,0,1,0,3,4,4,0},
		{0,0,3,3,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage62Data = {
		{1,0,1,1,0,0,0,0},
		{1,4,1,4,1,1,3,3},
		{0,0,0,0,0,1,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,0,0,0,0,0,0,1},
		{1,1,0,0,0,0,1,1},
		{1,1,1,0,0,1,1,1}
	};
	private static int[,] stage61Data = {
		{0,4,0,3,0,4,0,0},
		{0,4,0,3,0,3,0,0},
		{0,4,0,3,0,4,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,0,0,0,0,0,0,0},
		{1,1,0,1,0,1,0,0},
		{1,1,0,1,1,1,1,0}
	};
	private static int[,] stage60Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,3,0,3,0,0},
		{0,0,0,0,4,0,0,0},
		{0,1,0,1,0,0,1,0},
		{0,1,0,1,0,0,1,0},
		{0,1,0,1,0,0,1,0},
		{0,1,0,1,0,0,1,0}
	};
	private static int[,] stage59Data = {
		{1,1,1,0,0,1,1,1},
		{1,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,1},
		{0,0,0,4,4,0,0,0},
		{0,0,4,1,1,4,0,0},
		{1,0,0,4,4,0,0,1},
		{1,0,0,0,0,0,0,1},
		{1,1,1,0,0,1,1,1}
	};
	/**
	 * *****************************************************
	 * new stages BEGIN
	 * *****************************************************
	 * */
	private static int[,] stage58Data = {
		{0,0,1,0,0,0,0,0},
		{0,0,0,1,0,0,0,0},
		{0,0,0,0,1,0,0,4},
		{0,0,1,0,0,0,1,0},
		{0,1,0,0,0,1,0,0},
		{4,0,0,1,0,0,0,0},
		{0,0,0,0,1,0,0,0},
		{0,0,0,0,0,1,0,0}
	};
	private static int[,] stage57Data = {
		{0,0,0,0,4,0,0,0},
		{0,0,0,0,1,0,0,0},
		{0,1,0,0,0,1,0,0},
		{0,1,0,0,0,0,1,0},
		{0,0,0,0,0,4,0,0},
		{0,0,1,1,1,1,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage56Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,1,1,1,0},
		{0,0,4,0,0,1,1,0},
		{0,0,0,4,0,0,1,0},
		{0,1,0,0,4,0,0,0},
		{0,1,1,0,0,4,0,0},
		{0,1,1,1,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage55Data = {
		{0,0,0,1,1,1,0,0},
		{0,0,0,1,0,1,0,0},
		{1,1,0,0,0,0,0,0},
		{1,0,0,4,0,0,1,1},
		{1,1,0,0,0,0,0,1},
		{0,0,0,0,3,0,1,1},
		{0,0,1,0,1,0,0,0},
		{0,0,1,1,1,0,0,0}
	};
	private static int[,] stage54Data = {
		{0,0,0,0,0,0,0,0},
		{1,1,0,0,0,0,1,1},
		{0,0,0,0,0,0,0,0},
		{0,0,4,1,1,3,0,0},
		{0,0,4,1,1,4,0,0},
		{0,0,0,0,0,0,0,0},
		{1,1,0,0,0,0,1,1},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage53Data = {
		{0,1,0,0,0,0,0,0},
		{0,0,1,0,1,0,1,1},
		{0,0,0,0,0,0,0,1},
		{0,0,0,4,0,0,0,0},
		{0,0,0,0,3,0,0,0},
		{1,0,1,0,1,0,0,0},
		{0,0,0,0,0,1,0,0},
		{0,0,0,0,0,0,1,0}
	};
	private static int[,] stage52Data = {
		{0,0,1,1,1,0,0,0},
		{0,0,0,1,0,0,0,0},
		{0,0,0,0,0,0,0,1},
		{1,0,0,0,4,0,1,1},
		{1,1,0,3,4,0,0,1},
		{1,0,0,0,0,0,0,0},
		{0,0,0,0,1,0,0,0},
		{0,0,0,1,1,1,0,0}
	};
	private static int[,] stage51Data = {
		{1,1,0,0,0,0,1,1},
		{1,0,0,0,0,0,1,1},
		{0,0,0,0,0,0,0,0},
		{1,1,0,0,0,0,0,1},
		{1,1,0,0,0,0,1,1},
		{0,0,0,0,0,0,0,0},
		{1,1,0,4,4,0,1,1},
		{1,1,0,0,3,0,1,1}
	};
	private static int[,] stage50Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,3,4,4,3,0,0},
		{0,0,0,0,0,0,0,0},
		{0,1,1,0,0,1,1,0},
		{0,0,0,0,0,0,0,0},
		{0,1,1,1,0,1,1,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage49Data = {
		{0,0,0,0,0,0,0,1},
		{0,4,0,0,0,0,1,0},
		{0,0,4,0,0,4,0,0},
		{0,0,0,0,1,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,0,0,0,0,0},
		{0,1,0,0,0,0,0,0},
		{1,0,0,0,0,0,0,0}
	};
	private static int[,] stage48Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,1,0,0,0,0,0,0},
		{0,1,4,0,0,4,1,0},
		{0,1,0,0,0,0,1,0},
		{0,1,0,1,1,0,1,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage47Data = {
		{0,0,0,3,3,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,3,3,4,4,3,3,0},
		{0,3,3,4,4,3,3,0},
		{0,0,0,3,3,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,0,3,3,0,0,0}
	};
	private static int[,] stage46Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,1,0,0,0,0,1,0},
		{0,0,1,0,3,1,0,0},
		{0,0,0,0,1,0,0,0},
		{0,0,0,1,0,0,0,0},
		{0,0,1,0,0,0,0,0}
	};
	private static int[,] stage45Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,4,3,1,0,0},
		{0,0,1,4,3,1,0,0},
		{0,0,1,4,4,1,0,0},
		{0,1,0,0,0,0,1,0},
		{0,1,0,0,0,0,1,0},
		{0,0,0,0,0,0,0,0}
	};
	/**
	 * *****************************************************
	 * new stages END
	 * *****************************************************
	 * */
	private static int[,] stage44Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,4,3,1,0,0},
		{0,0,1,4,3,1,0,0},
		{0,0,0,4,4,0,0,0},
		{0,0,1,0,0,1,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage43Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,4,4,4,4,0,0},
		{0,0,0,0,0,0,0,0},
		{1,1,1,0,0,1,1,1},
		{1,1,0,0,0,0,1,1},
		{1,0,0,0,0,0,0,1}
	};
	private static int[,] stage42Data = {
		{0,0,4,3,3,4,0,0},
		{0,0,0,4,4,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,1,0,0,0,0,1,1},
		{1,1,0,0,0,0,1,1},
		{0,0,0,0,0,0,0,0},
		{1,1,0,0,0,0,1,1},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage41Data = {
		{1,4,1,0,0,1,4,1},
		{1,4,1,0,0,1,4,1},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage40Data = {
		{0,0,0,0,0,0,0,0},
		{0,1,0,0,0,0,1,0},
		{0,1,3,3,3,3,1,0},
		{0,0,0,0,4,0,0,0},
		{0,0,0,4,0,0,0,0},
		{0,1,3,3,3,3,1,0},
		{0,1,0,0,0,0,1,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage39Data = {
		{0,0,0,3,3,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,1,1,1,0,0},
		{0,0,0,1,1,0,0,0},
		{0,1,1,1,1,1,1,0}
	};
	private static int[,] stage38Data = {
		{0,0,0,0,0,0,0,0},
		{0,1,0,0,0,0,1,0},
		{0,0,1,0,0,1,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,1,0,0,1,0,0},
		{0,1,0,0,0,0,1,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage37Data = {
		{0,0,0,0,0,0,0,0},
		{0,1,0,0,0,0,1,0},
		{0,0,3,3,3,3,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,3,3,3,3,0,0},
		{0,1,0,0,0,0,1,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage36Data = {
		{0,0,0,0,0,1,1,1},
		{0,0,0,0,0,1,0,1},
		{0,3,0,0,0,1,3,1},
		{0,0,3,3,3,3,0,0},
		{1,1,3,0,0,3,0,0},
		{1,0,3,0,0,3,0,0},
		{1,1,3,3,3,3,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage35Data = {
		{1,1,0,0,0,0,0,1},
		{1,1,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0},
		{1,0,3,3,3,3,0,0},
		{0,0,3,1,1,3,0,0},
		{0,0,3,1,1,3,0,0},
		{0,0,3,3,3,3,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage34Data = {
		{1,1,3,0,0,3,1,1},
		{1,3,0,0,0,0,3,1},
		{3,0,0,0,0,0,0,3},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,0,0,0,0,0,0,1},
		{1,1,0,0,0,0,1,1},
		{1,1,1,0,0,1,1,1}
	};
	private static int[,] stage33Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,3,0,0,0,0,3,0},
		{0,0,3,0,0,3,0,0},
		{0,0,1,3,3,1,0,0},
		{0,0,1,0,0,1,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage32Data = {
		{1,1,0,0,0,0,1,1},
		{1,0,0,1,1,0,0,1},
		{0,0,0,0,0,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,1,3,3,1,0,0},
		{0,0,0,3,3,0,0,0}
	};
	private static int[,] stage31Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,3,3,0,0},
		{0,0,0,0,1,3,0,0},
		{0,1,3,3,0,0,0,0},
		{0,0,3,3,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage30Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,3,3,0},
		{0,0,0,0,3,3,0,0},
		{0,0,0,3,3,0,0,0},
		{1,0,1,1,0,0,0,0}
	};
	private static int[,] stage29Data = {
		{0,0,3,3,3,3,0,0},
		{0,0,3,3,3,3,0,0},
		{0,0,1,1,1,3,0,0},
		{0,0,3,3,3,3,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage28Data = {
		{0,0,0,0,0,0,0,0},
		{0,1,4,0,0,0,0,0},
		{0,3,1,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,4,3,3,4,0,0},
		{0,0,1,1,1,1,0,0}
	};
	private static int[,] stage27Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,1,1,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,1,1,0,0,0,0},
		{0,0,1,0,0,4,4,0},
		{0,0,0,0,0,4,4,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage26Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,1,0,0,0,0},
		{0,0,1,1,0,0,0,0},
		{0,0,0,0,1,1,1,0},
		{0,0,0,0,0,1,4,0},
		{0,0,0,0,1,4,0,0},
		{0,0,0,0,0,0,0,0}
	};
	/*
	 * **********************************************z
	 * chain 1
	 * **********************************************
	 * */
	private static int[,] stage25Data = {
		//dead level
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,1,1,0,0,1,1,0},
		{0,0,1,0,0,1,0,0},
		{0,0,1,0,0,1,0,0},
		{0,0,1,0,0,1,0,0}
	};
	private static int[,] stage24Data = {
		//dead level
		{0,0,0,0,1,0,0,0},
		{0,0,0,1,0,0,0,0},
		{0,0,1,0,0,0,0,0},
		{0,1,0,0,0,0,0,0},
		{0,0,0,0,1,1,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,1,1,0,0,0,0},
		{0,1,1,0,0,0,0,0}
	};
	private static int[,] stage23Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,1,1,1,1,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,0,0,1,0,0},
		{0,1,1,0,0,1,1,0},
		{0,0,1,0,0,1,0,0},
		{0,0,1,1,1,1,0,0},
		{0,0,0,1,1,0,0,0}
	};
	private static int[,] stage22Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,1,0,0,1,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage21Data = {
		//dead level
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,3,0,0,1,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,1,1,1,1,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage20Data = {
		{0,0,0,0,4,0,0,0},
		{0,0,0,0,0,1,1,0},
		{0,0,0,0,0,0,1,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,1,0},
		{0,0,0,0,0,1,0,0},
		{0,0,0,0,1,3,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage19Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,1,1,1,0,0},
		{0,0,1,0,0,0,0,0},
		{0,0,0,0,0,1,0,0},
		{0,0,1,1,1,1,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage18Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,1,0,0,0,0,1,0},
		{0,1,0,0,0,0,1,0},
		{0,1,1,0,0,1,1,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage17Data = {
		{0,0,1,1,1,1,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,4,4,0,0,3,4,0},
		{0,0,0,3,3,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,0,0,0,0,0,0,1},
		{1,1,0,0,0,0,1,1}
	};
	private static int[,] stage16Data = {
		{0,0,1,1,1,1,0,0},
		{0,0,1,0,0,1,0,0},
		{0,0,1,0,0,1,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,0,0,0,0,0},
		{1,0,1,1,0,0,0,0},
		{1,0,0,0,0,0,0,0},
		{1,1,1,0,0,0,0,0}
	};
	private static int[,] stage15Data = {
		{1,0,0,1,1,0,0,1},
		{0,0,0,1,1,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,0,0,1,0,0},
		{0,0,1,1,1,1,0,0},
		{0,0,0,1,1,0,0,0}
	};
	private static int[,] stage14Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,0,1,0,0,1,0,1},
		{1,0,1,0,0,1,0,1},
		{0,0,3,0,0,3,0,0},
		{0,3,3,0,0,3,3,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,1,1,0,0,0}
	};
	private static int[,] stage13Data = {
		{0,0,0,3,3,0,0,0},
		{0,0,0,3,3,0,0,0},
		{0,0,1,1,1,1,0,0},
		{0,0,1,0,0,1,0,0},
		{0,0,1,0,0,1,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage12Data = {
		//dead level
		{1,0,0,3,3,0,0,1},
		{0,0,0,3,3,0,0,0},
		{0,0,3,3,3,3,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage11Data = {
		{1,1,1,0,0,0,0,0},
		{1,1,0,0,0,0,0,0},
		{1,3,3,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,3,3,1},
		{0,0,0,0,0,0,1,1},
		{0,0,0,0,0,1,1,1}
	};
	private static int[,] stage10Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,1,0,0,1,3,0},
		{0,0,1,0,3,1,0,0},
		{0,3,1,0,3,1,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage9Data = {
		{0,0,0,0,0,1,1,1},
		{0,0,0,0,0,1,1,1},
		{0,0,0,3,3,3,1,1},
		{0,0,0,0,3,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,1,0,0,0,0,0,0},
		{1,1,1,0,0,0,0,0},
		{1,1,1,0,0,0,0,0}
	};
	private static int[,] stage8Data = {
		{0,1,0,0,0,0,0,0},
		{0,0,1,0,0,0,0,0},
		{0,0,0,1,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,1,0,0,0},
		{0,0,0,1,1,1,0,0},
		{0,0,1,1,1,1,1,0}
	};
	private static int[,] stage7Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,1,1,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage6Data = {
		{0,1,1,1,1,1,0,0},
		{0,0,1,1,1,0,0,0},
		{0,0,0,1,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,1,0,0,0},
		{0,0,0,1,1,1,0,0},
		{0,0,1,1,1,1,1,0}
	};
	private static int[,] stage5Data = {
		{1,1,0,0,0,0,1,1},
		{1,0,0,0,0,0,0,1},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,0,1,0,0,1,0,1},
		{1,1,0,0,0,0,1,1}
	};
	private static int[,] stage4Data = {
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,1},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage3Data = {
		{1,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,1},
		{0,0,0,0,0,0,0,0},
		{1,0,0,0,0,0,0,1},
		{1,1,0,0,0,0,1,1},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}
	};
	private static int[,] stage2Data = {
		{1,1,0,0,0,0,1,1},
		{1,1,0,0,0,0,1,1},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{1,0,0,0,0,0,0,1},
		{1,1,0,0,0,0,1,1}
	};
	
	static int [,] _data = null;
	/**
	 * return wall num of current stage
	 * */
	public static int GetStageData(int stage, int[,] targetData)
	{
		_data = null;
		int wallBlocks = 0;
		//stage=15;
		switch(stage)
		{
		case 1:
			_data = stage1Data;
			break;
		case 2:
			_data = stage2Data;
			break;
		case 3:
			_data = stage3Data;
			break;
		case 4:
			_data = stage4Data;
			break;
		case 5:
			_data = stage5Data;
			break;
		case 6:
			_data = stage6Data;
			break;
		case 7:
			_data = stage7Data;
			break;
		case 8:
			_data = stage8Data;
			break;
		case 9:
			_data = stage9Data;
			break;
		case 10:
			_data = stage10Data;
			break;
		case 11:
			_data = stage11Data;
			break;
		case 12:
			_data = stage12Data;
			break;
		case 13:
			_data = stage13Data;
			break;
		case 14:
			_data = stage14Data;
			break;
		case 15:
			_data = stage15Data;
			break;
		case 16:
			_data = stage16Data;
			break;
		case 17:
			_data = stage17Data;
			break;
		case 18:
			_data = stage18Data;
			break;
		case 19:
			_data = stage19Data;
			break;
		case 20:
			_data = stage20Data;
			break;
		case 21:
			_data = stage21Data;
			break;
		case 22:
			_data = stage22Data;
			break;
		case 23:
			_data = stage23Data;
			break;
		case 24:
			_data = stage24Data;
			break;
		case 25:
			_data = stage25Data;
			break;
		case 26:
			_data = stage26Data;
			break;
		case 27:
			_data = stage27Data;
			break;
		case 28:
			_data = stage28Data;
			break;
		case 29:
			_data = stage29Data;
			break;
		case 30:
			_data = stage30Data;
			break;
		case 31:
			_data = stage31Data;
			break;
		case 32:
			_data = stage32Data;
			break;
		case 33:
			_data = stage33Data;
			break;
		case 34:
			_data = stage34Data;
			break;
		case 35:
			_data = stage35Data;
			break;
		case 36:
			_data = stage36Data;
			break;
		case 37:
			_data = stage37Data;
			break;
		case 38:
			_data = stage38Data;
			break;
		case 39:
			_data = stage39Data;
			break;
		case 40:
			_data = stage40Data;
			break;
		case 41:
			_data = stage41Data;
			break;
		case 42:
			_data = stage42Data;
			break;
		case 43:
			_data = stage43Data;
			break;
		case 44:
			_data = stage44Data;
			break;
		case 45:
			_data = stage45Data;
			break;
		case 46:
			_data = stage46Data;
			break;
		case 47:
			_data = stage47Data;
			break;
		case 48:
			_data = stage48Data;
			break;
		case 49:
			_data = stage49Data;
			break;
		case 50:
			_data = stage50Data;
			break;
		case 51:
			_data = stage51Data;
			break;
		case 52:
			_data = stage52Data;
			break;
		case 53:
			_data = stage53Data;
			break;
		case 54:
			_data = stage54Data;
			break;
		case 55:
			_data = stage55Data;
			break;
		case 56:
			_data = stage56Data;
			break;
		case 57:
			_data = stage57Data;
			break;
		case 58:
			_data = stage58Data;
			break;
		case 59:
			_data = stage59Data;
			break;
		case 60:
			_data = stage60Data;
			break;
		case 61:
			_data = stage61Data;
			break;
		case 62:
			_data = stage62Data;
			break;
		case 63:
			_data = stage63Data;
			break;
		case 64:
			_data = stage64Data;
			break;
		case 65:
			_data = stage65Data;
			break;
		case 66:
			_data = stage66Data;
			break;
		case 67:
			_data = stage67Data;
			break;
		case 68:
			_data = stage68Data;
			break;
		case 69:
			_data = stage69Data;
			break;
		case 70:
			_data = stage70Data;
			break;
		case 71:
			_data = stage71Data;
			break;
		case 72:
			_data = stage72Data;
			break;
		case 73:
			_data = stage73Data;
			break;
		case 74:
			_data = stage74Data;
			break;
		case 75:
			_data = stage75Data;
			break;
		case 76:
			_data = stage76Data;
			break;
		case 77:
			_data = stage77Data;
			break;
		case 78:
			_data = stage78Data;
			break;
		case 79:
			_data = stage79Data;
			break;
		case 80:
			_data = stage80Data;
			break;
			
			
		case 81:
			_data = stage81Data;
			break;
		case 82:
			_data = stage82Data;
			break;
		case 83:
			_data = stage83Data;
			break;
		case 84:
			_data = stage84Data;
			break;
		case 85:
			_data = stage85Data;
			break;
		case 86:
			_data = stage86Data;
			break;
		case 87:
			_data = stage87Data;
			break;
		case 88:
			_data = stage88Data;
			break;
		case 89:
			_data = stage89Data;
			break;
		case 90:
			_data = stage90Data;
			break;
		case 91:
			_data = stage91Data;
			break;
		case 92:
			_data = stage92Data;
			break;
		case 93:
			_data = stage93Data;
			break;
		case 94:
			_data = stage94Data;
			break;
		case 95:
			_data = stage95Data;
			break;
		case 96:
			_data = stage96Data;
			break;
		case 97:
			_data = stage97Data;
			break;
		case 98:
			_data = stage98Data;
			break;
		case 99:
			_data = stage99Data;
			break;
		case 100:
			_data = stage100Data;
			break;
		case 101:
			_data = stage101Data;
			break;
		case 102:
			_data = stage102Data;
			break;
		case 103:
			_data = stage103Data;
			break;
		case 104:
			_data = stage104Data;
			break;
		case 105:
			_data = stage105Data;
			break;
		case 106:
			_data = stage106Data;
			break;
		case 107:
			_data = stage107Data;
			break;
		case 108:
			_data = stage108Data;
			break;
		case 109:
			_data = stage109Data;
			break;
		case 110:
			_data = stage110Data;
			break;
		case 111:
			_data = stage111Data;
			break;
		case 112:
			_data = stage112Data;
			break;
		case 113:
			_data = stage113Data;
			break;
		case 114:
			_data = stage114Data;
			break;
		case 115:
			_data = stage115Data;
			break;
		case 116:
			_data = stage116Data;
			break;
		case 117:
			_data = stage117Data;
			break;
		case 118:
			_data = stage118Data;
			break;
		case 119:
			_data = stage119Data;
			break;
		case 120:
			_data = stage120Data;
			break;
		case 121:
			_data = stage121Data;
			break;
		case 122:
			_data = stage122Data;
			break;
		case 123:
			_data = stage123Data;
			break;
		case 124:
			_data = stage124Data;
			break;
		case 125:
			_data = stage125Data;
			break;
		case 126:
			_data = stage126Data;
			break;
		case 127:
			_data = stage127Data;
			break;
		case 128:
			_data = stage128Data;
			break;
		}
		
		if(_data==null)
			return 0;
		
		for(int i=0; i<8; i++)
		{
			for(int j=0; j<8; j++)
			{
				targetData[i,j] = _data[i,j];
				if(_data[i,j] == BACKGROUND_WALL ||
				   _data[i,j] == BACKGROUND_WALL_TYPE1 || 
				   _data[i,j] == BACKGROUND_WALL_TYPE2|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE1|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE2|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE3|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE4|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE5)
					wallBlocks++;
			}
		}
		return wallBlocks;
	}

	public static int GetStageWallNum()
	{
		int wallBlocks = 0;
		
		if(_data==null)
			return 0;
		
		for(int i=0; i<11; i++)
		{
			for(int j=0; j<9; j++)
			{
				if(_data[i,j] == BACKGROUND_WALL ||
				   _data[i,j] == BACKGROUND_WALL_TYPE1 || 
				   _data[i,j] == BACKGROUND_WALL_TYPE2|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE1|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE2|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE3|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE4|| 
				   _data[i,j] == BACKGROUND_ICE_TYPE5)
					wallBlocks++;
			}
		}
		
		return wallBlocks;
	}

}